summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMart Raudsepp <leio@gentoo.org>2020-03-12 13:55:35 +0200
committerMart Raudsepp <leio@gentoo.org>2020-03-12 14:52:17 +0200
commita0d708e1c540d2618b1a510ee65f99a1b2284fde (patch)
treeca5bf4cc180f1569e5fb69e8cbdde9035ee89014 /dev-util
parentapp-editors/notepadqq: Added dev-qt/qtwebsockets to DEPEND (diff)
downloadgentoo-a0d708e1c540d2618b1a510ee65f99a1b2284fde.tar.gz
gentoo-a0d708e1c540d2618b1a510ee65f99a1b2284fde.tar.bz2
gentoo-a0d708e1c540d2618b1a510ee65f99a1b2284fde.zip
dev-util/gnome-builder: bump to 3.34.1
Package-Manager: Portage-2.3.84, Repoman-2.3.20 Signed-off-by: Mart Raudsepp <leio@gentoo.org>
Diffstat (limited to 'dev-util')
-rw-r--r--dev-util/gnome-builder/Manifest2
-rw-r--r--dev-util/gnome-builder/files/3.34.1-optional-vala.patch42
-rw-r--r--dev-util/gnome-builder/gnome-builder-3.34.1.ebuild192
3 files changed, 236 insertions, 0 deletions
diff --git a/dev-util/gnome-builder/Manifest b/dev-util/gnome-builder/Manifest
index 808a9df9a29..ed8ab782cb7 100644
--- a/dev-util/gnome-builder/Manifest
+++ b/dev-util/gnome-builder/Manifest
@@ -1,3 +1,5 @@
DIST gnome-builder-3.30.3.tar.xz 9486164 BLAKE2B b983fd71b1bab31386ab8f4c3a6ff57b33afd2da5aff5e41e7d1cba388a9b6998a0f799c0843bde95f8ce0456fe46457d0c0c46622d59eeb7729d2e8868898f7 SHA512 468605dbd2bd712a76c333a974bb19ca889dfe8493c2e85101641034f3e2c8eba2c0ee2f98ad01f3466f0f42946f05790763ccfaf786d73da192d64360eec47f
DIST gnome-builder-3.32.4-patchset.tar.xz 34740 BLAKE2B 6e29ce42b2b1878b5fcec7cf057bcdc015da8817d7f9209f4d03e02bb5837525e329d0627d4465123fb20a0a46415053d7e08b445634659123ebff12d2fb9d09 SHA512 494cf1ff370c7d86d42ec352966169e73b99556dc5a1be0bf0ec53cd78e8550897bb44187ae8f471fe3e10a85dc7d44d44c5edef0569b1d0a7dff7b5d78b1fa1
DIST gnome-builder-3.32.4.tar.xz 11886980 BLAKE2B a7901566238dd39fe180d1e47089d7f99018be115f407d174472a8371374361fe50f2f15cb6d496a1afa3e30117d83788944636fb6a9487d4a719442ba6ae744 SHA512 a050161465edd448b0359ff781bf97b0cda6c184ea4f89193711a1bac3c7b79f76bac0d3600e3823a86aa19538228619b5d64aea94e8a67f480b5c1f79bc3b93
+DIST gnome-builder-3.34.1-patchset.tar.xz 44680 BLAKE2B 91e91ac8d0fcf6b54d32ce9f1dc209ac22db790a29d724dad20e337fe1962f3d407b59e7f976f1e88277833849c962a470346bb5a308e39b637e6e9ca1dc2c2a SHA512 a114346b093976db227087743a7bbe2ca9523b64a67c95729bfeb7c3c346b3bfb4d02f5e11d36bbbaf506bc7a7f140883bdea7c78407243287bc400dfda43b57
+DIST gnome-builder-3.34.1.tar.xz 11974748 BLAKE2B c34a31c50b327d02632ff18d48ad59f925306901e8874e0c7811b9258c56027403de0d9dc1877c696d96037bdfcdcc27f56f59a41d232e47b330382b1dbf67e9 SHA512 886c732f20563818dcf1deb96d4277fe96a9499b999cfbc7a64286e816e9a36bb978932d36a1e764b54c2d36891b7546fa058f51e036b0fa101c0872f4ce51d8
diff --git a/dev-util/gnome-builder/files/3.34.1-optional-vala.patch b/dev-util/gnome-builder/files/3.34.1-optional-vala.patch
new file mode 100644
index 00000000000..6116de17267
--- /dev/null
+++ b/dev-util/gnome-builder/files/3.34.1-optional-vala.patch
@@ -0,0 +1,42 @@
+From 84249e315c4a95b3ef9421dbf8492e10422e40d9 Mon Sep 17 00:00:00 2001
+From: Mart Raudsepp <leio@gentoo.org>
+Date: Thu, 12 Mar 2020 13:28:38 +0200
+Subject: [PATCH] build: Make vapi generation optional
+
+---
+ meson_options.txt | 1 +
+ src/meson.build | 2 ++
+ 2 files changed, 3 insertions(+)
+
+diff --git a/meson_options.txt b/meson_options.txt
+index 8984e9f69..27f9a368b 100644
+--- a/meson_options.txt
++++ b/meson_options.txt
+@@ -13,6 +13,7 @@ option('channel',
+
+ option('help', type: 'boolean', value: false)
+ option('docs', type: 'boolean', value: false)
++option('vapi', type: 'boolean')
+
+ option('network_tests', type: 'boolean', value: true, description: 'Allow networking in unit-tests')
+
+diff --git a/src/meson.build b/src/meson.build
+index 113a142ad..b0510270b 100644
+--- a/src/meson.build
++++ b/src/meson.build
+@@ -134,6 +134,7 @@ libide_gir = gnome.generate_gir(gnome_builder,
+ extra_args: gnome_builder_gir_extra_args,
+ )
+
++if get_option('vapi')
+ configure_file(
+ input: 'libide.deps',
+ output: 'libide-' + libide_api_version + '.deps',
+@@ -165,3 +166,4 @@ libide_vapi = gnome.generate_vapi('libide-' + libide_api_version,
+
+ # Must be after vapi generation
+ subdir('plugins/vala-pack')
++endif
+--
+2.20.1
+
diff --git a/dev-util/gnome-builder/gnome-builder-3.34.1.ebuild b/dev-util/gnome-builder/gnome-builder-3.34.1.ebuild
new file mode 100644
index 00000000000..694f1dc3272
--- /dev/null
+++ b/dev-util/gnome-builder/gnome-builder-3.34.1.ebuild
@@ -0,0 +1,192 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+PYTHON_COMPAT=( python3_{6,7,8} )
+VALA_MIN_API_VERSION="0.36"
+DISABLE_AUTOFORMATTING=1
+FORCE_PRINT_ELOG=1
+
+inherit gnome.org gnome2-utils llvm meson python-single-r1 readme.gentoo-r1 vala virtualx xdg
+
+DESCRIPTION="An IDE for writing GNOME-based software"
+HOMEPAGE="https://wiki.gnome.org/Apps/Builder"
+SRC_URI+=" https://dev.gentoo.org/~leio/distfiles/${P}-patchset.tar.xz"
+
+# FIXME: Review licenses at some point
+LICENSE="GPL-3+ GPL-2+ LGPL-3+ LGPL-2+ MIT CC-BY-SA-3.0 CC0-1.0"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE="clang +devhelp doc +git +glade gtk-doc spell sysprof test vala"
+REQUIRED_USE="${PYTHON_REQUIRED_USE}"
+
+# When bumping, pay attention to all the included plugins/*/meson.build (and other) build files and the requirements within.
+# `grep -rI dependency * --include='meson.build'` can give a good initial idea for external deps and their double checking.
+# The listed RDEPEND order shold roughly match that output as well, with toplevel one first then sorted by file path.
+# Most plugins have no extra requirements and default to enabled; we need to handle the ones with extra requirements. Many of
+# them have optional runtime dependencies, for which we try to at least notify the user via DOC_CONTENTS (but not all small
+# things); `grep -rI -e 'command-pattern.*=' -e 'push_arg'` can give a (spammy) idea, plus python imports in try/except.
+
+# FIXME: plugin_flatpak needs flatpak.pc >=0.8.0, ostree-1, libsoup-2.4.pc >=2.52.0 and git plugin enabled
+# Editorconfig needs old pcre, with vte migrating away, might want it optional or ported to pcre2?
+# An introspection USE flag of a dep is required if any introspection based language plugin wants to use it (grep for gi.repository). Last full check at 3.28.4
+
+# TODO: Handle llvm slots via llvm.eclass; see plugins/clang/meson.build
+RDEPEND="
+ >=dev-libs/libdazzle-3.33.90[introspection,vala?]
+ >=dev-libs/glib-2.61.2:2
+ >=x11-libs/gtk+-3.22.26:3[introspection]
+ >=x11-libs/gtksourceview-4.0.0:4[introspection]
+ >=dev-libs/json-glib-1.2.0
+ >=dev-libs/jsonrpc-glib-3.19.91[vala?]
+ >=x11-libs/pango-1.38.0
+ >=dev-libs/libpeas-1.22.0[python,${PYTHON_SINGLE_USEDEP}]
+ >=dev-libs/template-glib-3.28.0[introspection,vala?]
+ >=x11-libs/vte-0.40.2:2.91[introspection,vala?]
+ >=net-libs/webkit-gtk-2.12.0:4=[introspection]
+ >=dev-libs/libxml2-2.9.0
+ git? ( dev-libs/libgit2[ssh,threads]
+ >=dev-libs/libgit2-glib-0.28.0.1[ssh]
+ )
+ dev-libs/libpcre:3
+ dev-libs/libpcre2
+
+ >=dev-libs/gobject-introspection-1.54.0:=
+ $(python_gen_cond_dep '
+ >=dev-python/pygobject-3.22.0:3[${PYTHON_MULTI_USEDEP}]
+ ')
+ ${PYTHON_DEPS}
+ clang? ( sys-devel/clang:= )
+ devhelp? ( >=dev-util/devhelp-3.25.1:= )
+ glade? ( >=dev-util/glade-3.22.0:3.10 )
+ spell? ( >=app-text/gspell-1.8:0=
+ app-text/enchant:2 )
+ >=dev-util/sysprof-capture-3.33.1:3
+ sysprof? ( >=dev-util/sysprof-3.33.4:0/3[gtk] )
+ vala? (
+ dev-lang/vala:=
+ $(vala_depend)
+ )
+" # We use subslot operator dep on vala in addition to $(vala_depend), because we have _runtime_
+# usage in vala-pack plugin and need it rebuilt before removing an older vala it was built against
+DEPEND="${RDEPEND}"
+# TODO: runtime ctags path finding..
+
+# desktop-file-utils required for tests, but we have it in deptree for xdg update-desktop-database anyway, so be explicit and unconditional
+# appstream-glib needed for validation with appstream-util with FEATURES=test
+BDEPEND="
+ doc? ( dev-python/sphinx )
+ gtk-doc? ( dev-util/gtk-doc
+ app-text/docbook-xml-dtd:4.3 )
+ test? (
+ dev-libs/appstream-glib
+ sys-apps/dbus )
+ dev-util/desktop-file-utils
+ dev-util/glib-utils
+ >=dev-util/meson-0.49.2
+ >=sys-devel/gettext-0.19.8
+ virtual/pkgconfig
+"
+
+DOC_CONTENTS='gnome-builder can use various other dependencies on runtime to provide
+extra capabilities beyond these expressed via USE flags. Some of these
+that are currently available with packages include:
+
+* dev-util/uncrustify and dev-python/autopep8 for various Code Beautifier
+ plugin out of the box functionality.
+* dev-util/ctags with exuberant-ctags selected via "eselect ctags" for
+ C, C++, Python, JavaScript, CSS, HTML and Ruby autocompletion, semantic
+ highlighting and symbol resolving support.
+* dev-python/jedi and dev-python/lxml for more accurate Python
+ autocompletion support.
+* dev-util/valgrind for integration with valgrind.
+* dev-util/meson for integration with the Meson build system.
+* dev-util/cargo for integration with the Rust Cargo build system.
+* dev-util/cmake for integration with the CMake build system.
+* net-libs/nodejs[npm] for integration with the NPM package system.
+'
+# FIXME: Package gnome-code-assistance and mention here, or maybe USE flag and default enable because it's rather important
+# eslint for additional diagnostics in JavaScript files (what package has this? At least something via NPM..)
+# jhbuild support
+# rust language server via rls; Go via go-langserver
+# autotools stuff for autotools plugin; gtkmm/autoconf-archive for C++ template
+# gjs/gettext/mono/PHPize stuff, but most of these are probably installed for other reasons anyways, when needed inside IDE
+
+PATCHES=(
+ "${WORKDIR}/patches" # gnome-builder-3-34 branch 2020-01-22 (commit bf485934b37) + cherry-picked meson link_whole fixes
+ "${FILESDIR}"/${PV}-optional-vala.patch
+)
+
+llvm_check_deps() {
+ has_version "sys-devel/clang:${LLVM_SLOT}"
+}
+
+pkg_setup() {
+ python-single-r1_pkg_setup
+ use clang && llvm_pkg_setup
+}
+
+src_prepare() {
+ use vala && vala_src_prepare
+ xdg_src_prepare
+}
+
+src_configure() {
+ local emesonargs=(
+ -Dtracing=false
+ -Dprofiling=false # not passing -pg to CFLAGS
+ -Dfusermount_wrapper=false # meant for flatpak builds
+ -Dtcmalloc=false
+ -Dchannel=other
+
+ $(meson_use vala vapi) # TODO: doesn't work anymore; crude patch included
+ $(meson_use doc help)
+ $(meson_use gtk-doc docs)
+
+ -Dnetwork_tests=false
+ $(meson_use clang plugin_clang)
+ $(meson_use devhelp plugin_devhelp)
+ -Dplugin_deviced=false
+ -Dplugin_editorconfig=true # needs libpcre
+ $(meson_use git plugin_git)
+ -Dplugin_flatpak=false
+ -Dplugin_podman=false
+ $(meson_use glade plugin_glade)
+ -Dplugin_git=true
+ $(meson_use spell plugin_spellcheck)
+ $(meson_use sysprof plugin_sysprof)
+ $(meson_use vala plugin_vala)
+ )
+ meson_src_configure
+}
+
+src_install() {
+ meson_src_install
+ python_optimize
+ if use doc; then
+ rm "${ED}"/usr/share/doc/gnome-builder/en/.buildinfo || die
+ rm "${ED}"/usr/share/doc/gnome-builder/en/objects.inv || die
+ rm -r "${ED}"/usr/share/doc/gnome-builder/en/.doctrees || die
+ # custom docdir in build system, blocked by https://github.com/mesonbuild/meson/issues/825
+ mv "${ED}"/usr/share/doc/gnome-builder/en "${ED}"/usr/share/doc/${PF}/html || die
+ # _sources subdir left in on purpose, as HTML links to the rst files as "View page source". Additionally default docompress exclusion of /html/ already ensures they aren't compressed, thus linkable as-is.
+ rmdir "${ED}"/usr/share/doc/gnome-builder/ || die
+ fi
+ readme.gentoo_create_doc
+}
+
+pkg_postinst() {
+ xdg_pkg_postinst
+ gnome2_schemas_update
+ readme.gentoo_print_elog
+}
+
+pkg_postrm() {
+ xdg_pkg_postrm
+ gnome2_schemas_update
+}
+
+src_test() {
+ # FIXME: can't run meson_src_test together with virtx or dbus-run-session
+ virtx dbus-run-session meson test -C "${BUILD_DIR}"
+}